freeslot(
"sfx_drpdsh",
"S_PLAY_DROPDASH",
"SPR2_DRPD",
"SPR_BONK"
)

assert(VERSION ~= nil, "script does not support game version")

sfxinfo[sfx_drpdsh] = {
	singular = false,
	caption = "Drop Dash"
}

states[S_PLAY_DROPDASH] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRPD,
	tics = 1,
	nextstate = S_PLAY_DROPDASH
}

addHook("ThinkFrame", do
	for player in players.iterate do
		if player.mo.skin == "sonic"
			if not (player.dropready)
				player.dropready = false
			end
			if not (player.spinprep)
				player.spinprep = 9
			end
			if (player.pflags & PF_JUMPED)
			and player.spinprep > 1
			and (player.dropbegin)
			and (player.cmd.buttons & BT_SPIN)
			and not (player.pflags & PF_THOKKED)
				player.spinprep = $1-1
				if player.spinprep == 1
					player.dropready = true
				end
			end
			if player.spinprep > 0
			and P_IsObjectOnGround(player.mo)
				player.spinprep = 0
			end
			if (player.dropready)
			and P_IsObjectOnGround(player.mo)
				player.dropready = false
			end
		end
		if (player.mo.skin == "sonic" and player.charability2 == CA2_SPINDASH)
			if (player.mo.dropcharged == nil)
				player.mo.dropcharged = false
			end
			if (player.mo.eflags & MFE_SPRUNG)
			or (player.powers[pw_carry] == (CR_PLAYER|CR_GENERIC|CR_ROPEHANG|CR_MACESPIN))
			or (player.exiting)
			or (player.pflags & PF_SLIDING)
			//or (player.powers[pw_shield] ~= SH_NONE)
			or (player.deadtimer)
			or P_PlayerInPain(player)
			or not(player.playerstate == PST_LIVE) 
			or P_CheckDeathPitCollide(player.mo, true)
				player.mo.dropcharged = false
			end
			if (player.mo.dropcharged == true)
			and not (P_PlayerInPain(player) or (player.deadtimer))
				if (player.mo.eflags & MFE_UNDERWATER)
					local particle3 = P_SpawnMobj(player.mo.x+(P_RandomRange(-16,16)*FRACUNIT), player.mo.y+(P_RandomRange(-16,16)*FRACUNIT), player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_PARTICLE].height)), MT_PARTICLE)
					particle3.state = S_SPINDUST_BUBBLE1
					particle3.bubble = true
					particle3.fuse = 20
					particle3.scale = player.mo.scale
					particle3.target = player.mo
					particle3.eflags = $1 | (player.mo.eflags & MFE_VERTICALFLIP)
					//particle3.scale = player.mo.scale*2/3
					P_SetObjectMomZ(particle3, 35*FRACUNIT/50+P_RandomByte()<<10, false)
					P_InstaThrust(particle3, player.mo.angle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-35*FRACUNIT/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
					P_TryMove(particle3, particle3.x+particle3.momx, particle3.y+particle3.momy, true)
				else
					local dropghost = P_SpawnGhostMobj(player.mo)
					dropghost.fuse = 4
					dropghost.frame = player.mo.frame|TR_TRANS80
					dropghost.state = S_THOK
					dropghost.sprite = SPR_BONK
				end
			end
			if (player.mo.dropcharged == false)
			and (player.mo.state == S_PLAY_DROPDASH)
			and P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_WALK
			end
			if not (P_PlayerInPain(player) or (player.deadtimer))
				if not (player.mo.eflags & MFE_JUSTHITFLOOR) then
					if not (player.cmd.buttons & BT_SPIN) and player.mo.dropcharged then
						player.mo.dropcharged = false
						if player.pflags&(PF_SPINNING) or (player.pflags&PF_JUMPED and not(player.pflags&PF_NOJUMPDAMAGE))
							player.mo.state = S_PLAY_ROLL
						end
					end
				else
					if (player.mo.dropcharged and player.cmd.buttons & BT_SPIN) then
						if S_SoundPlaying(player.mo, sfx_drpdsh)
							S_StopSound(player.mo)
						end
						player.pflags = $1|PF_SPINNING
						player.mo.dropcharged = false
						player.mo.state = S_PLAY_ROLL
						if player.speed < player.actionspd+20*FRACUNIT
						and player.speed > player.actionspd
							if player.powers[pw_super]
								P_StartQuake(10*FRACUNIT, 5, {player.mo.x,player.mo.y,player.mo.z}, 35 * FRACUNIT)
								S_StartSound(player.mo, sfx_cdfm01)
							else
								S_StartSound(player.mo, sfx_zoom)
							end
							P_InstaThrust(player.mo, player.mo.angle, player.speed)
						elseif player.speed > 60*FRACUNIT
							if player.powers[pw_super]
								P_StartQuake(10*FRACUNIT, 5, {player.mo.x,player.mo.y,player.mo.z}, 35 * FRACUNIT)
								if player.mo.eflags&MFE_UNDERWATER
									P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
								else
									P_InstaThrust(player.mo, player.mo.angle, 70*FRACUNIT)
								end
								S_StartSound(player.mo, sfx_cdfm01)
							else
								if player.mo.eflags&MFE_UNDERWATER
									P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
								else
									P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
								end
								S_StartSound(player.mo, sfx_zoom)
							end
						elseif player.speed < 40*FRACUNIT
							if player.powers[pw_super]
								P_StartQuake(10*FRACUNIT, 5, {player.mo.x,player.mo.y,player.mo.z}, 35 * FRACUNIT)
								if player.mo.eflags&MFE_UNDERWATER
									P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
								else
									P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
								end
								S_StartSound(player.mo, sfx_cdfm01)
							else
								if player.mo.eflags&MFE_UNDERWATER
									P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
								else
									P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
								end
								S_StartSound(player.mo, sfx_zoom)
							end
						end
						for i=(leveltime%88)/2,(leveltime%88) do
							local particle2 = P_SpawnMobj(player.mo.x, player.mo.y,
								player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_PARTICLE].height)),
								MT_PARTICLE)
							if (player.powers[pw_shield] == SH_ELEMENTAL and not (player.mo.eflags & MFE_TOUCHWATER or player.mo.eflags & MFE_UNDERWATER)) then
								particle2.state = S_SPINDUST_FIRE1
								particle2.bubble = false
								particle2.fuse = 20
							elseif (player.mo.eflags & MFE_TOUCHWATER or player.mo.eflags & MFE_UNDERWATER) then
								particle2.state = S_SPINDUST_BUBBLE1
								particle2.bubble = true
								particle2.fuse = 20
							else
								particle2.state = S_SPINDUST1
								particle2.bubble = false
								particle2.fuse = 20
							end
							if (player.mo.eflags & MFE_GOOWATER) then
								particle2.flags2 = $1|MF2_DONTDRAW
							else
								particle2.flags2 = $1 & ~MF2_DONTDRAW
							end
							particle2.target = player.mo
							particle2.eflags = $1 | (player.mo.eflags & MFE_VERTICALFLIP)
							particle2.scale = player.mo.scale*2/3
							P_SetObjectMomZ(particle2, 35*FRACUNIT/50+P_RandomByte()<<10, false)
							P_InstaThrust(particle2, player.mo.angle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-35*FRACUNIT/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
							P_TryMove(particle2, particle2.x+particle2.momx, particle2.y+particle2.momy, true)
						end
					end
				end
			end
		end
		if not (player.mo.skin == "sonic")
			if not (player.mo.dropcharged == nil)
				player.mo.dropcharged = nil
			end
		end
		if not (player.dropbegin)
			player.dropbegin = false
		end
		if (player.dropbegin)
		and P_IsObjectOnGround(player.mo)
			player.dropbegin = false
			player.charability = skins[player.mo.skin].ability
		end
	end
end)

addHook("JumpSpinSpecial", function(player)
	if player.mo.skin == "sonic" and player.pflags&PF_JUMPED and not(player.pflags&PF_SPINDOWN) and not (player.pflags & PF_THOKKED)
		player.dropbegin = 1
		player.charability = CA_NONE
	return true end
end)

addHook("MobjThinker", function(mo)
	if (mo.skin == "sonic")
	and (mo.player.charability2 == CA2_SPINDASH)
	and not (mo.player.pflags & PF_SLIDING)
	and (mo.player.pflags & PF_JUMPED)
	and (mo.player.dropready)
	and (mo.player.cmd.buttons & BT_SPIN)
	and not (mo.state >= S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS6)
	and not (P_PlayerInPain(mo.player) or (mo.player.deadtimer))
	and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE) then
		if not (mo.player.pflags & PF_THOKKED) 
		and mo.dropcharged == false then
			mo.player.pflags = $1|PF_THOKKED
			mo.dropcharged = true
			mo.state = S_PLAY_DROPDASH
			S_StartSound(mo, sfx_drpdsh)
		end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo)
	local p = mo
	if p.dropcharged
		p.dropcharged = false
	end
end, MT_PLAYER)

if rawget(_G, "onedustthinker") return end

rawset(_G, "onedustthinker", true)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) then return end
	if (mo.state >= S_SPINDUST1 and mo.state < S_SPINDUST_FIRE1) or (mo.state >= S_SPINDUST_FIRE1 and mo.state < S_SPINDUST_BUBBLE1) or (mo.state >= S_SPINDUST_BUBBLE1) then
		mo.momx = FixedMul($1, 50000)
		mo.momy = FixedMul($1, 50000)
		mo.momz = $1+P_MobjFlip(mo)/3
	end
	if (mo.bubble) and (mo.watertop ~= mo.subsector.sector.floorheight - 1000*FRACUNIT) and (mo.z+mo.height >= mo.watertop - 5*FRACUNIT) then
		mo.flags2 = $1|MF2_DONTDRAW
	end
end, MT_PARTICLE)